'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = function (WrappedComponent, injectables) {

  return function (_Component) {
    _inherits(ReactInjectorComponent, _Component);

    function ReactInjectorComponent(props) {
      _classCallCheck(this, ReactInjectorComponent);

      var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ReactInjectorComponent).call(this, props));

      _this.propsToInject = getPropsFromInjectables(injectables);
      _this.onUpdate = _this.onUpdate.bind(_this);
      return _this;
    }

    _createClass(ReactInjectorComponent, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        var _this2 = this;

        Object.keys(this.propsToInject).forEach(function (item) {
          var dependency = _this2.propsToInject[item];

          if (typeof dependency.subscribe === 'function') {
            dependency.subscribe(_this2.onUpdate);
          }
        });
      }
    }, {
      key: 'onUpdate',
      value: function onUpdate(data) {
        this.setState(_extends({}, this.props, data));
      }
    }, {
      key: 'render',
      value: function render() {

        return (0, _react.createElement)(WrappedComponent, _extends({}, this.props, this.propsToInject));
      }
    }]);

    return ReactInjectorComponent;
  }(_react.Component);
};

var _react = require('react');

var _serenitydi = require('serenitydi');

var _serenitydi2 = _interopRequireDefault(_serenitydi);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getPropsFromInjectables(injectables) {

  var injectKeys = Object.keys(injectables);
  var injectVals = _serenitydi2.default.fetchAll(injectKeys.map(function (key) {
    return injectables[key];
  }));

  var newProps = injectVals.reduce(function (newProps, dep1, index) {
    newProps[injectKeys[index]] = dep1;
    return newProps;
  }, {});

  return newProps;
}

module.exports = exports['default'];